import React from 'react';
import { SchemaInitializerItemType, useCollectionDataSource } from '@tachybase/client';
import { FilterDynamicComponent } from '../..';
import { Instruction } from '../../nodes/default-node/interface';
declare function AssociatedConfig({ value, onChange, ...props }: {
    [x: string]: any;
    value: any;
    onChange: any;
}): JSX.Element;
/** 节点:  聚合查询 */
export default class extends Instruction {
    title: string;
    type: string;
    group: string;
    icon: string;
    color: string;
    description: string;
    fieldset: {
        aggregator: {
            type: string;
            title: string;
            'x-decorator': string;
            'x-component': string;
            enum: {
                label: string;
                value: string;
            }[];
            required: boolean;
            default: string;
        };
        associated: {
            type: string;
            title: string;
            'x-decorator': string;
            'x-component': string;
            enum: {
                label: string;
                value: boolean;
            }[];
            required: boolean;
            default: boolean;
            'x-reactions': {
                target: string;
                effects: string[];
                fulfill: {
                    state: {
                        value: any;
                    };
                };
            }[];
        };
        collectionField: {
            type: string;
            'x-decorator': string;
            'x-decorator-props': {
                value: {
                    designable: boolean;
                };
            };
            'x-component': string;
            properties: {
                row: {
                    type: string;
                    'x-component': string;
                    properties: {
                        target: {
                            type: string;
                            'x-component': string;
                            properties: {
                                collection: {
                                    type: string;
                                    required: boolean;
                                    'x-decorator': string;
                                    'x-component': string;
                                    title: string;
                                    'x-reactions': ({
                                        dependencies: string[];
                                        fulfill: {
                                            state: {
                                                display: string;
                                                value?: undefined;
                                            };
                                        };
                                        target?: undefined;
                                        effects?: undefined;
                                    } | {
                                        target: string;
                                        effects: string[];
                                        fulfill: {
                                            state: {
                                                value: any;
                                                display?: undefined;
                                            };
                                        };
                                        dependencies?: undefined;
                                    })[];
                                };
                                association: {
                                    type: string;
                                    title: string;
                                    'x-decorator': string;
                                    'x-component': string;
                                    'x-component-props': {
                                        changeOnSelect: boolean;
                                    };
                                    'x-reactions': {
                                        dependencies: string[];
                                        fulfill: {
                                            state: {
                                                visible: string;
                                            };
                                        };
                                    }[];
                                    required: boolean;
                                };
                            };
                        };
                        field: {
                            type: string;
                            'x-component': string;
                            properties: {
                                'params.field': {
                                    type: string;
                                    title: string;
                                    'x-decorator': string;
                                    'x-component': string;
                                    'x-component-props': {
                                        filter(field: any): boolean;
                                    };
                                    required: boolean;
                                    'x-reactions': {
                                        dependencies: string[];
                                        fulfill: {
                                            state: {
                                                visible: string;
                                            };
                                        };
                                    }[];
                                };
                            };
                        };
                    };
                };
            };
        };
        params: {
            type: string;
            properties: {
                distinct: {
                    type: string;
                    title: string;
                    'x-decorator': string;
                    'x-component': string;
                    'x-reactions': {
                        dependencies: string[];
                        fulfill: {
                            state: {
                                visible: string;
                            };
                        };
                    }[];
                };
                filter: {
                    type: string;
                    title: string;
                    'x-decorator': string;
                    'x-component': string;
                    'x-use-component-props': () => {
                        options: any[];
                        className: string;
                    };
                    'x-component-props': {
                        dynamicComponent: string;
                    };
                    'x-reactions': {
                        dependencies: string[];
                        fulfill: {
                            state: {
                                visible: string;
                            };
                        };
                    }[];
                };
            };
        };
    };
    scope: {
        useCollectionDataSource: typeof useCollectionDataSource;
    };
    components: {
        SchemaComponentContext: React.Context<import("@tachybase/client").ISchemaComponentContext>;
        FilterDynamicComponent: typeof FilterDynamicComponent;
        FieldsSelect: React.MemoExoticComponent<import("@tachybase/schema").ReactFC<Omit<any, "ref">>>;
        ValueBlock: (() => JSX.Element) & {
            Initializer: () => JSX.Element;
            Result: (props: any) => JSX.Element;
            Designer: () => JSX.Element;
        };
        AssociatedConfig: typeof AssociatedConfig;
    };
    useVariables({ key, title }: {
        key: any;
        title: any;
    }, { types, fieldNames }: {
        types: any;
        fieldNames?: {
            readonly label: "label";
            readonly value: "value";
            readonly children: "children";
        };
    }): {
        value: any;
        label: any;
    };
    useInitializers(node: any): SchemaInitializerItemType | null;
}
export {};
