import { SchemaInitializerItemType } from '@tachybase/client';
import { WorkflowVariableInput } from '../..';
import { Instruction } from '../../nodes/default-node/interface';
declare function DynamicExpression({ value, onChange }: {
    value: any;
    onChange: any;
}): import("react/jsx-runtime").JSX.Element;
export default class extends Instruction {
    title: string;
    type: string;
    group: string;
    icon: string;
    color: string;
    description: string;
    fieldset: {
        expression: {
            type: string;
            title: string;
            'x-decorator': string;
            'x-component': string;
            required: boolean;
        };
        scope: {
            type: string;
            title: string;
            'x-decorator': string;
            'x-component': string;
            'x-component-props': {
                changeOnSelect: boolean;
                variableOptions: {
                    types: {
                        type: string;
                        options: {
                            collection: string;
                            entity: boolean;
                        };
                    }[];
                };
            };
            'x-reactions': {
                dependencies: string[];
                fulfill: {
                    state: {
                        visible: string;
                    };
                };
            };
        };
    };
    components: {
        DynamicExpression: typeof DynamicExpression;
        WorkflowVariableInput: typeof WorkflowVariableInput;
        ValueBlock: (() => JSX.Element) & {
            Initializer: () => JSX.Element;
            Result: (props: any) => JSX.Element;
            Designer: () => JSX.Element;
        };
    };
    useVariables({ key, title }: {
        key: any;
        title: any;
    }, { types, fieldNames }: {
        types: any;
        fieldNames?: {
            readonly label: "label";
            readonly value: "value";
            readonly children: "children";
        };
    }): {
        value: any;
        label: any;
    };
    useInitializers(node: any): SchemaInitializerItemType;
}
export {};
