import { useCollectionDataSource } from '@tachybase/client';
import { CollectionBlockInitializer } from '../../components';
import { Trigger } from '../../triggers';
import { UseVariableOptions } from '../../variable';
export declare class OmniActionTrigger extends Trigger {
    title: string;
    description: string;
    fieldset: {
        bindCollection: {
            type: string;
            title: string;
            'x-decorator': string;
            'x-component': string;
            enum: {
                label: string;
                value: boolean;
            }[];
            required: boolean;
            default: boolean;
        };
        collection: {
            type: string;
            title: string;
            'x-decorator': string;
            'x-component': string;
            required: boolean;
            'x-reactions': ({
                target: string;
                effects: string[];
                fulfill: {
                    state: {
                        value: any[];
                        visible?: undefined;
                    };
                };
                dependencies?: undefined;
            } | {
                dependencies: string[];
                fulfill: {
                    state: {
                        visible: string;
                        value?: undefined;
                    };
                };
                target?: undefined;
                effects?: undefined;
            })[];
        };
        appends: {
            type: string;
            title: string;
            description: string;
            'x-decorator': string;
            'x-component': string;
            'x-component-props': {
                multiple: boolean;
                useCollection(): any;
            };
            'x-reactions': {
                dependencies: string[];
                fulfill: {
                    state: {
                        visible: string;
                    };
                };
            }[];
        };
    };
    scope: {
        useCollectionDataSource: typeof useCollectionDataSource;
    };
    components: {};
    isActionTriggerable: (config: any, context?: any) => boolean;
    useVariables(config: Record<string, any>, options?: UseVariableOptions): import("../..").VariableOption[];
    useInitializers(config: any): {
        name: string;
        type: string;
        key: string;
        title: string;
        Component: typeof CollectionBlockInitializer;
        collection: any;
        dataPath: string;
    };
}
