import { WorkflowVariableInput, WorkflowVariableJSON, WorkflowVariableTextArea } from '../..';
import { Instruction } from '../../nodes/default-node/interface';
/** 节点: HTTP 请求 */
export default class extends Instruction {
    title: string;
    type: string;
    group: string;
    icon: string;
    color: string;
    description: string;
    fieldset: {
        method: {
            type: string;
            required: boolean;
            title: string;
            'x-decorator': string;
            'x-component': string;
            'x-component-props': {
                showSearch: boolean;
                allowClear: boolean;
                className: string;
            };
            enum: {
                label: string;
                value: string;
            }[];
            default: string;
        };
        url: {
            type: string;
            required: boolean;
            title: string;
            'x-decorator': string;
            'x-decorator-props': {};
            'x-component': string;
            'x-component-props': {
                placeholder: string;
            };
        };
        needAuthorization: {
            type: string;
            required: boolean;
            title: string;
            'x-decorator': string;
            'x-component': string;
            'x-component-props': {
                showSearch: boolean;
                allowClear: boolean;
                className: string;
            };
            enum: {
                label: string;
                value: boolean;
            }[];
            default: boolean;
        };
        headers: {
            type: string;
            'x-component': string;
            'x-decorator': string;
            title: string;
            description: string;
            items: {
                type: string;
                properties: {
                    space: {
                        type: string;
                        'x-component': string;
                        properties: {
                            name: {
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-component-props': {
                                    placeholder: string;
                                };
                            };
                            value: {
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-component-props': {
                                    useTypedConstant: boolean;
                                };
                            };
                            remove: {
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                            };
                        };
                    };
                };
            };
            properties: {
                add: {
                    type: string;
                    title: string;
                    'x-component': string;
                };
            };
        };
        params: {
            type: string;
            'x-component': string;
            'x-decorator': string;
            title: string;
            items: {
                type: string;
                properties: {
                    space: {
                        type: string;
                        'x-component': string;
                        properties: {
                            name: {
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-component-props': {
                                    placeholder: string;
                                };
                            };
                            value: {
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                                'x-component-props': {
                                    useTypedConstant: boolean;
                                };
                            };
                            remove: {
                                type: string;
                                'x-decorator': string;
                                'x-component': string;
                            };
                        };
                    };
                };
            };
            properties: {
                add: {
                    type: string;
                    title: string;
                    'x-component': string;
                };
            };
        };
        data: {
            type: string;
            title: string;
            'x-decorator': string;
            'x-decorator-props': {};
            'x-component': string;
            'x-component-props': {
                changeOnSelect: boolean;
                autoSize: {
                    minRows: number;
                };
                placeholder: string;
            };
            description: string;
        };
        comment: {
            type: string;
            title: string;
            'x-decorator': string;
            'x-decorator-props': {};
            'x-component': string;
            'x-component-props': {
                autoSize: {
                    minRows: number;
                };
                placeholder: string;
            };
        };
        timeout: {
            type: string;
            title: string;
            'x-decorator': string;
            'x-decorator-props': {};
            'x-component': string;
            'x-component-props': {
                addonAfter: string;
                min: number;
                step: number;
                defaultValue: number;
            };
        };
        ignoreFail: {
            type: string;
            title: string;
            'x-decorator': string;
            'x-component': string;
        };
    };
    components: {
        ArrayItems: import("packages/schema/lib").ReactFC<import("react").HTMLAttributes<HTMLDivElement>> & import("@tachybase/components").ArrayBaseMixins & {
            Item: import("packages/schema/lib").ReactFC<React.HTMLAttributes<HTMLDivElement> & {
                type?: "card" | "divide";
            }>;
        };
        WorkflowVariableInput: typeof WorkflowVariableInput;
        WorkflowVariableTextArea: typeof WorkflowVariableTextArea;
        WorkflowVariableJSON: typeof WorkflowVariableJSON;
    };
    useVariables({ key, title }: {
        key: any;
        title: any;
    }, { types, fieldNames }: {
        types: any;
        fieldNames?: {
            readonly label: "label";
            readonly value: "value";
            readonly children: "children";
        };
    }): {
        value: any;
        label: any;
    };
}
