import { VariableOption, WorkflowVariableInput } from '../..';
import { Instruction } from '../../nodes/default-node/interface';
export declare class ScriptInstruction extends Instruction {
    title: string;
    type: string;
    group: string;
    icon: string;
    color: string;
    isHot: boolean;
    description: string;
    fieldset: {
        sourceArray: {
            type: string;
            title: string;
            description: string;
            'x-decorator': string;
            'x-component': string;
            items: {
                type: string;
                properties: {
                    keyName: {
                        type: string;
                        'x-component': string;
                        'x-component-props': {
                            title: string;
                        };
                        properties: {
                            keyName: {
                                type: string;
                                name: string;
                                'x-decorator': string;
                                'x-component': string;
                            };
                        };
                    };
                    sourcePath: {
                        type: string;
                        'x-component': string;
                        'x-component-props': {
                            title: string;
                        };
                        properties: {
                            sourcePath: {
                                type: string;
                                name: string;
                                required: boolean;
                                'x-decorator': string;
                                'x-component': string;
                                'x-component-props': {
                                    changeOnSelect: boolean;
                                };
                            };
                        };
                    };
                    operations: {
                        type: string;
                        'x-component': string;
                        'x-component-props': {
                            dataIndex: string;
                            fixed: string;
                            className: string;
                        };
                        properties: {
                            remove: {
                                type: string;
                                'x-component': string;
                            };
                        };
                    };
                };
            };
            properties: {
                add: {
                    type: string;
                    title: string;
                    'x-component': string;
                    'x-component-props': {
                        defaultValue: {};
                    };
                };
            };
        };
        type: {
            type: string;
            title: string;
            'x-decorator': string;
            'x-component': string;
            enum: {
                label: string;
                value: string;
            }[];
            default: string;
        };
        code: {
            type: string;
            title: string;
            'x-decorator': string;
            'x-component': string;
            'x-component-props': {
                defaultLanguage: string;
                height: string;
                defaultValue: string;
            };
        };
        model: {
            type: string;
            title: string;
            description: string;
            'x-decorator': string;
            'x-component': string;
            items: {
                type: string;
                properties: {
                    path: {
                        type: string;
                        'x-component': string;
                        'x-component-props': {
                            title: string;
                        };
                        properties: {
                            path: {
                                type: string;
                                name: string;
                                required: boolean;
                                'x-decorator': string;
                                'x-component': string;
                            };
                        };
                    };
                    alias: {
                        type: string;
                        'x-component': string;
                        'x-component-props': {
                            title: string;
                        };
                        properties: {
                            alias: {
                                type: string;
                                name: string;
                                'x-decorator': string;
                                'x-component': string;
                            };
                        };
                    };
                    label: {
                        type: string;
                        'x-component': string;
                        'x-component-props': {
                            title: string;
                        };
                        properties: {
                            label: {
                                type: string;
                                name: string;
                                required: boolean;
                                'x-decorator': string;
                                'x-component': string;
                            };
                        };
                    };
                    operations: {
                        type: string;
                        'x-component': string;
                        'x-component-props': {
                            dataIndex: string;
                            fixed: string;
                            className: string;
                        };
                        properties: {
                            remove: {
                                type: string;
                                'x-component': string;
                            };
                        };
                    };
                };
            };
            properties: {
                add: {
                    type: string;
                    title: string;
                    'x-component': string;
                    'x-component-props': {
                        defaultValue: {};
                    };
                };
            };
        };
    };
    components: {
        ArrayTable: import("packages/schema/lib").ReactFC<import("antd").TableProps<any>> & import("@tachybase/components").ArrayBaseMixins & {
            Column: import("packages/schema/lib").ReactFC<import("antd").TableColumnProps<any>>;
            Addition: import("packages/schema/lib").ReactFC<import("@tachybase/components").IArrayBaseAdditionProps>;
        };
        WorkflowVariableInput: typeof WorkflowVariableInput;
    };
    useVariables(node: any, options: any): VariableOption;
}
