import { WorkflowVariableRawTextArea } from '../..';
import { Instruction } from '../../nodes/default-node/interface';
/** 节点: SQL */
export default class extends Instruction {
    title: string;
    type: string;
    group: string;
    icon: string;
    color: string;
    description: string;
    fieldset: {
        dataSource: {
            type: string;
            required: boolean;
            title: string;
            description: string;
            'x-decorator': string;
            'x-component': string;
            'x-component-props': {
                className: string;
                filter(item: any): any;
            };
            default: string;
        };
        sql: {
            type: string;
            required: boolean;
            title: string;
            'x-decorator': string;
            'x-component': string;
            'x-component-props': {
                rows: number;
                className: string;
            };
        };
    };
    components: {
        WorkflowVariableRawTextArea: typeof WorkflowVariableRawTextArea;
    };
    useVariables({ key, title }: {
        key: any;
        title: any;
    }, { types, fieldNames }: {
        types: any;
        fieldNames?: {
            readonly label: "label";
            readonly value: "value";
            readonly children: "children";
        };
    }): {
        value: any;
        label: any;
    };
}
