import { Instruction } from '../../nodes/default-node/interface';
/** 节点: 工作流 */
export declare class TriggerInstruction extends Instruction {
    title: string;
    type: string;
    group: string;
    icon: string;
    color: string;
    fieldset: {
        workflowKey: {
            type: string;
            title: string;
            name: string;
            'x-decorator': string;
            'x-component': string;
            'x-component-props': {
                buttonAction: string;
                noCollection: boolean;
                label: string;
                value: string;
            };
            'x-use-component-props': () => {
                parentSync: any;
                parentKey: any;
            };
            required: boolean;
        };
        bindCollection: {
            type: string;
            title: string;
            'x-decorator': string;
            'x-component': string;
            enum: {
                label: string;
                value: boolean;
            }[];
            required: boolean;
            default: boolean;
        };
        collection: {
            type: string;
            title: string;
            'x-decorator': string;
            'x-component': string;
            required: boolean;
            'x-reactions': ({
                target: string;
                effects: string[];
                fulfill: {
                    state: {
                        value: any[];
                        visible?: undefined;
                    };
                };
                dependencies?: undefined;
            } | {
                dependencies: string[];
                fulfill: {
                    state: {
                        visible: string;
                        value?: undefined;
                    };
                };
                target?: undefined;
                effects?: undefined;
            })[];
        };
        appends: {
            type: string;
            title: string;
            description: string;
            'x-decorator': string;
            'x-component': string;
            'x-component-props': {
                multiple: boolean;
                useCollection(): any;
            };
            'x-reactions': {
                dependencies: string[];
                fulfill: {
                    state: {
                        visible: string;
                    };
                };
            }[];
        };
    };
    useVariables({ key: name, title, config }: {
        key: any;
        title: any;
        config: any;
    }, options: any): import("../..").VariableOption;
}
