import { ISchema } from '@tachybase/schema';
export declare const executionCollection: {
    name: string;
    fields: {
        interface: string;
        type: string;
        name: string;
        uiSchema: ISchema;
    }[];
};
export declare const getExecutionSchema: (params?: any) => {
    type: string;
    name: string;
    title: string;
    'x-component': string;
    properties: {
        content: {
            type: string;
            'x-decorator': string;
            'x-decorator-props': {
                collection: {
                    name: string;
                    fields: {
                        interface: string;
                        type: string;
                        name: string;
                        uiSchema: ISchema;
                    }[];
                };
                dataSource: string;
                action: string;
                params: {
                    appends: string[];
                    pageSize: number;
                    sort: string[];
                };
            };
            properties: {
                actions: {
                    type: string;
                    'x-component': string;
                    'x-component-props': {
                        style: {
                            marginBottom: number;
                        };
                    };
                    properties: {
                        refresher: {
                            type: string;
                            title: string;
                            'x-action': string;
                            'x-component': string;
                            'x-use-component-props': string;
                            'x-designer': string;
                            'x-component-props': {
                                icon: string;
                            };
                            'x-align': string;
                        };
                        clear: {
                            type: string;
                            title: string;
                            'x-component': string;
                            'x-component-props': {
                                isShow: any;
                                useAction(): {
                                    run(): Promise<void>;
                                };
                                confirm: {
                                    title: string;
                                    content: string;
                                };
                            };
                        };
                    };
                };
                table: {
                    type: string;
                    'x-component': string;
                    'x-use-component-props': string;
                    'x-component-props': {
                        rowKey: string;
                    };
                    properties: {
                        actions: {
                            type: string;
                            title: string;
                            'x-component': string;
                            'x-component-props': {
                                width: number;
                            };
                            properties: {
                                actions: {
                                    type: string;
                                    'x-component': string;
                                    'x-component-props': {
                                        split: string;
                                    };
                                    properties: {
                                        link: {
                                            type: string;
                                            'x-component': string;
                                        };
                                    };
                                };
                            };
                        };
                        id: {
                            type: string;
                            'x-decorator': string;
                            'x-component': string;
                            'x-component-props': {
                                width: number;
                            };
                            properties: {
                                id: {
                                    type: string;
                                    'x-component': string;
                                    'x-read-pretty': boolean;
                                };
                            };
                        };
                        createdAt: {
                            type: string;
                            'x-decorator': string;
                            'x-component': string;
                            'x-component-props': {
                                width: number;
                            };
                            properties: {
                                createdAt: {
                                    type: string;
                                    'x-component': string;
                                    'x-component-props': {
                                        showTime: boolean;
                                    };
                                    'x-read-pretty': boolean;
                                };
                            };
                        };
                        executionTime: {
                            type: string;
                            title: string;
                            'x-decorator': string;
                            'x-component': string;
                            'x-component-props': {
                                width: number;
                            };
                            properties: {
                                executionTime: {
                                    type: string;
                                    'x-decorator': string;
                                    'x-component': string;
                                    'x-read-pretty': boolean;
                                };
                            };
                        };
                        workflowId: {
                            type: string;
                            'x-decorator': string;
                            'x-component': string;
                            'x-component-props': {
                                width: number;
                            };
                            properties: {
                                workflowId: {
                                    type: string;
                                    'x-component': string;
                                    'x-read-pretty': boolean;
                                };
                            };
                        };
                        status: {
                            type: string;
                            title: string;
                            'x-decorator': string;
                            'x-component': string;
                            'x-component-props': {
                                width: number;
                            };
                            properties: {
                                status: {
                                    type: string;
                                    'x-decorator': string;
                                    'x-component': string;
                                    'x-read-pretty': boolean;
                                };
                            };
                        };
                    };
                };
            };
        };
    };
};
export declare const executionSchema: {
    type: string;
    name: string;
    title: string;
    'x-component': string;
    properties: {
        content: {
            type: string;
            'x-decorator': string;
            'x-decorator-props': {
                collection: {
                    name: string;
                    fields: {
                        interface: string;
                        type: string;
                        name: string;
                        uiSchema: ISchema;
                    }[];
                };
                dataSource: string;
                action: string;
                params: {
                    appends: string[];
                    pageSize: number;
                    sort: string[];
                };
            };
            properties: {
                actions: {
                    type: string;
                    'x-component': string;
                    'x-component-props': {
                        style: {
                            marginBottom: number;
                        };
                    };
                    properties: {
                        refresher: {
                            type: string;
                            title: string;
                            'x-action': string;
                            'x-component': string;
                            'x-use-component-props': string;
                            'x-designer': string;
                            'x-component-props': {
                                icon: string;
                            };
                            'x-align': string;
                        };
                        clear: {
                            type: string;
                            title: string;
                            'x-component': string;
                            'x-component-props': {
                                isShow: any;
                                useAction(): {
                                    run(): Promise<void>;
                                };
                                confirm: {
                                    title: string;
                                    content: string;
                                };
                            };
                        };
                    };
                };
                table: {
                    type: string;
                    'x-component': string;
                    'x-use-component-props': string;
                    'x-component-props': {
                        rowKey: string;
                    };
                    properties: {
                        actions: {
                            type: string;
                            title: string;
                            'x-component': string;
                            'x-component-props': {
                                width: number;
                            };
                            properties: {
                                actions: {
                                    type: string;
                                    'x-component': string;
                                    'x-component-props': {
                                        split: string;
                                    };
                                    properties: {
                                        link: {
                                            type: string;
                                            'x-component': string;
                                        };
                                    };
                                };
                            };
                        };
                        id: {
                            type: string;
                            'x-decorator': string;
                            'x-component': string;
                            'x-component-props': {
                                width: number;
                            };
                            properties: {
                                id: {
                                    type: string;
                                    'x-component': string;
                                    'x-read-pretty': boolean;
                                };
                            };
                        };
                        createdAt: {
                            type: string;
                            'x-decorator': string;
                            'x-component': string;
                            'x-component-props': {
                                width: number;
                            };
                            properties: {
                                createdAt: {
                                    type: string;
                                    'x-component': string;
                                    'x-component-props': {
                                        showTime: boolean;
                                    };
                                    'x-read-pretty': boolean;
                                };
                            };
                        };
                        executionTime: {
                            type: string;
                            title: string;
                            'x-decorator': string;
                            'x-component': string;
                            'x-component-props': {
                                width: number;
                            };
                            properties: {
                                executionTime: {
                                    type: string;
                                    'x-decorator': string;
                                    'x-component': string;
                                    'x-read-pretty': boolean;
                                };
                            };
                        };
                        workflowId: {
                            type: string;
                            'x-decorator': string;
                            'x-component': string;
                            'x-component-props': {
                                width: number;
                            };
                            properties: {
                                workflowId: {
                                    type: string;
                                    'x-component': string;
                                    'x-read-pretty': boolean;
                                };
                            };
                        };
                        status: {
                            type: string;
                            title: string;
                            'x-decorator': string;
                            'x-component': string;
                            'x-component-props': {
                                width: number;
                            };
                            properties: {
                                status: {
                                    type: string;
                                    'x-decorator': string;
                                    'x-component': string;
                                    'x-read-pretty': boolean;
                                };
                            };
                        };
                    };
                };
            };
        };
    };
};
