import { SchemaInitializerItemType, useCollectionDataSource } from '@tachybase/client';
import { Trigger } from '.';
import { useWorkflowAnyExecuted } from '../hooks';
export default class extends Trigger {
    title: string;
    description: string;
    fieldset: {
        collection: {
            'x-disabled': string;
            'x-component-props': {
                dataSourceFilter(item: any): any;
            };
            "x-reactions": any[];
            type: string;
            title: string;
            required: boolean;
            'x-decorator': string;
            'x-component': string;
        };
        mode: {
            type: string;
            title: string;
            'x-decorator': string;
            'x-component': string;
            'x-component-props': {
                popupMatchSelectWidth: boolean;
                placeholder: string;
                className: string;
            };
            enum: {
                label: string;
                value: number;
            }[];
            required: boolean;
            'x-reactions': {
                dependencies: string[];
                fulfill: {
                    state: {
                        visible: string;
                    };
                };
            }[];
        };
        blacklist: {
            type: string;
            title: string;
            description: string;
            'x-decorator': string;
            'x-component': string;
            'x-component-props': {
                mode: string;
                placeholder: string;
                filter(field: any): boolean;
            };
            'x-reactions': {
                dependencies: string[];
                fulfill: {
                    state: {
                        visible: string;
                    };
                };
            }[];
        };
        changed: {
            type: string;
            title: string;
            description: string;
            'x-decorator': string;
            'x-component': string;
            'x-component-props': {
                mode: string;
                placeholder: string;
                filter(field: any): boolean;
            };
            'x-reactions': {
                dependencies: string[];
                fulfill: {
                    state: {
                        visible: string;
                    };
                };
            }[];
        };
        condition: {
            title: string;
            'x-component-props': {};
            'x-reactions': {
                dependencies: string[];
                fulfill: {
                    state: {
                        visible: string;
                    };
                };
            }[];
            type: string;
            'x-decorator': string;
            'x-component': string;
            'x-use-component-props': () => {
                options: any[];
                className: string;
            };
        };
        appends: {
            'x-reactions': {
                dependencies: string[];
                fulfill: {
                    state: {
                        visible: string;
                    };
                };
            }[];
            type: string;
            title: string;
            description: string;
            'x-decorator': string;
            'x-component': string;
            'x-component-props': {
                title: string;
                multiple: boolean;
                useCollection(): any;
            };
        };
    };
    scope: {
        useCollectionDataSource: typeof useCollectionDataSource;
        useWorkflowAnyExecuted: typeof useWorkflowAnyExecuted;
    };
    components: {
        FieldsSelect: import("react").MemoExoticComponent<import("packages/schema/lib").ReactFC<Omit<any, "ref">>>;
    };
    useVariables(config: any, options: any): import("..").VariableOption[];
    useInitializers(config: any): SchemaInitializerItemType | null;
}
