import { Registry } from '@tachybase/utils';
import WorkflowPlugin, { Instruction, Processor } from '../..';
import { FormHandler } from './forms';
type FormType = {
    type: 'custom' | 'create' | 'update';
    actions: number[];
    options: {
        [key: string]: any;
    };
};
export interface ManualConfig {
    schema: {
        [key: string]: any;
    };
    forms: {
        [key: string]: FormType;
    };
    assignees?: (number | string)[];
    mode?: number;
}
export default class extends Instruction {
    workflow: WorkflowPlugin;
    formTypes: Registry<FormHandler>;
    constructor(workflow: WorkflowPlugin);
    run(node: any, prevJob: any, processor: Processor): Promise<any>;
    resume(node: any, job: any, processor: Processor): Promise<any>;
}
export {};
