import { AxiosRequestConfig } from 'axios';
import { FlowNodeModel, Instruction, Processor } from '../..';
export interface Header {
    name: string;
    value: string;
}
export type RequestConfig = Pick<AxiosRequestConfig, 'url' | 'method' | 'params' | 'data' | 'timeout'> & {
    headers: Array<Header>;
    ignoreFail: boolean;
};
export default class extends Instruction {
    run(node: FlowNodeModel, prevJob: any, processor: Processor): Promise<any>;
    resume(node: FlowNodeModel, job: any, processor: Processor): Promise<any>;
}
