var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var TriggerInstruction_exports = {};
__export(TriggerInstruction_exports, {
  TriggerInstruction: () => TriggerInstruction
});
module.exports = __toCommonJS(TriggerInstruction_exports);
var import_constants = require("../../constants");
var import_instructions = __toESM(require("../../instructions"));
class TriggerInstruction extends import_instructions.default {
  async run(node, input, processor) {
    const workflowKey = node.config.workflowKey;
    const wfRepo = this.workflow.db.getRepository("workflows");
    const wf = await wfRepo.findOne({ filter: { key: workflowKey, enabled: true } });
    if (wf.sync) {
      const p = await this.workflow.trigger(wf, input.result);
      if (!p) {
        return {
          status: import_constants.JOB_STATUS.FAILED
        };
      }
      const { lastSavedJob } = p;
      return {
        status: import_constants.JOB_STATUS.RESOLVED,
        result: lastSavedJob == null ? void 0 : lastSavedJob.result
      };
    } else {
      this.workflow.trigger(wf, input.result, {
        parentNode: node.id,
        parent: processor.execution
      });
      return {
        status: import_constants.JOB_STATUS.PENDING
      };
    }
  }
  async resume(node, prevJob, processor) {
    prevJob.set("result", prevJob.result);
    prevJob.set("status", prevJob.status);
    return prevJob;
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  TriggerInstruction
});
