var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var VariableInstruction_exports = {};
__export(VariableInstruction_exports, {
  VariablesInstruction: () => VariablesInstruction
});
module.exports = __toCommonJS(VariableInstruction_exports);
var import_constants = require("../../constants");
var import_instructions = __toESM(require("../../instructions"));
class VariablesInstruction extends import_instructions.default {
  async run(node, prevJob, processor) {
    const { target, value } = node.config;
    const result = processor.getParsedValue(value, node.id);
    if (target) {
      const targetNode = processor.nodes.find((item) => item.key === target);
      if (!targetNode) {
        throw new Error(`target node by key "${target}" is not found`);
      }
      await processor.saveJob({
        status: import_constants.JOB_STATUS.RESOLVED,
        result,
        nodeId: targetNode.id,
        nodeKey: target,
        upstreamId: prevJob && prevJob.id || null
      });
    }
    return {
      status: import_constants.JOB_STATUS.RESOLVED,
      result
    };
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  VariablesInstruction
});
