var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var Plugin_exports = {};
__export(Plugin_exports, {
  PluginWebhook: () => PluginWebhook
});
module.exports = __toCommonJS(Plugin_exports);
var import_path = __toESM(require("path"));
var import_server = require("@tachybase/server");
var import_lodash = __toESM(require("lodash"));
var import_webhooks = require("./webhooks");
class PluginWebhook extends import_server.Plugin {
  async load() {
    this.app.on("afterStart", async () => {
      const webhooksRepo = this.db.getRepository("webhooks");
      const resources = await webhooksRepo.find({
        filter: {
          enabled: true,
          type: "resource"
        }
      });
      for (const resourceDef of resources) {
        if (!this.app.resourcer.isDefined(resourceDef.resourceName)) {
          this.app.resourcer.define({ name: resourceDef.resourceName });
        }
        this.app.resourcer.getResource(resourceDef.resourceName).addAction(resourceDef.actionName, async (ctx) => {
          const body = await new import_webhooks.WebhookController().action(ctx, resourceDef);
          await new import_webhooks.WebhookController().triggerWorkflow(ctx, resourceDef, body);
        });
        this.app.acl.allow(resourceDef.resourceName, resourceDef.actionName, "loggedIn");
      }
    });
    await this.db.import({
      directory: import_path.default.resolve(__dirname, "collections")
    });
    this.app.resourcer.define({
      name: "webhooks",
      actions: {
        trigger: new import_webhooks.WebhookController().getLink,
        test: new import_webhooks.WebhookController().test
      }
    });
    this.app.acl.allow("webhooks", ["trigger", "test"], "loggedIn");
    const app = this.app;
    this.app.acl.use(
      async (ctx, next) => {
        if (import_lodash.default.isEmpty(ctx.action.params)) {
          await next();
          return;
        }
        const { resourceName, actionName } = ctx.action;
        const webhooksRepo = ctx.db.getRepository("webhooks");
        const actions = await app.cache.wrap(
          "webhooks",
          async () => {
            return await webhooksRepo.find({
              filter: {
                enabled: true,
                type: "action"
              }
            });
          },
          30 * 60 * 1e3
        );
        const actionObj = {};
        const actionList = actions.filter((action) => {
          return resourceName === action["resourceName"] && actionName === action["actionName"];
        });
        for (const action of actionList) {
          actionObj[action.id] = await new import_webhooks.WebhookController().action(ctx, action);
        }
        await next();
        for (const action of actionList) {
          await new import_webhooks.WebhookController().triggerWorkflow(ctx, action, actionObj[action.id]);
        }
      },
      { tag: "api-webhook", after: "core" }
    );
  }
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  PluginWebhook
});
