var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
var webhooks_exports = {};
__export(webhooks_exports, {
  WebhookController: () => WebhookController
});
module.exports = __toCommonJS(webhooks_exports);
var import_utils = require("@tachybase/utils");
var import_lodash = __toESM(require("lodash"));
var import__ = require("../..");
function isSameBasic(val1, val2) {
  if (val1 instanceof Date || val2 instanceof Date) {
    return new Date(val1).getTime() === new Date(val2).getTime();
  }
  return val1 === val2;
}
function getLostKey(smallOne, bigOne, path = "") {
  const lostKeys = /* @__PURE__ */ new Set();
  if (typeof bigOne !== "object" || bigOne === null) {
    if (smallOne === void 0) {
      return [path];
    }
    return [];
  }
  const bigKeys = Object.keys(bigOne);
  for (const key of bigKeys) {
    let keyLabel = path ? `${path}.${key}` : key;
    if (Array.isArray(bigOne)) {
      keyLabel = path;
    }
    if ((smallOne == null ? void 0 : smallOne[key]) === void 0) {
      lostKeys.add(keyLabel);
      continue;
    } else {
      const result = getLostKey(smallOne == null ? void 0 : smallOne[key], bigOne == null ? void 0 : bigOne[key], keyLabel);
      for (const item of result) {
        lostKeys.add(item);
      }
    }
  }
  return [...lostKeys];
}
function getDiffKeyExceptAfter(before, after, path = "") {
  if (after === null || after === void 0) {
    return [];
  }
  if (typeof before !== "object" || typeof after !== "object" || before === null || after === null) {
    if (!isSameBasic(before, after)) {
      return [path];
    } else {
      return [];
    }
  }
  if (Array.isArray(before) && Array.isArray(after) && before.length !== after.length) {
    return [path];
  }
  const beforeDiffKeys = /* @__PURE__ */ new Set();
  const beforeKeys = Object.keys(before);
  for (const key of beforeKeys) {
    if ((after == null ? void 0 : after[key]) === void 0) {
      continue;
    }
    let keyLabel = path ? `${path}.${key}` : key;
    if (Array.isArray(after)) {
      keyLabel = path;
    }
    if ((before == null ? void 0 : before[key]) === void 0) {
      beforeDiffKeys.add(keyLabel);
      continue;
    } else {
      const result = getDiffKeyExceptAfter(before == null ? void 0 : before[key], after == null ? void 0 : after[key], keyLabel);
      for (const item of result) {
        beforeDiffKeys.add(item);
      }
    }
  }
  return [...beforeDiffKeys];
}
function getChanged(ctx) {
  return async function() {
    try {
      const params = import_lodash.default.cloneDeep(ctx.action.params);
      const repo = ctx.db.getRepository(ctx.action.resourceName);
      const fieldsObj = {};
      const app = ctx.app;
      const c = app.mainDataSource.collectionManager.getCollection(ctx.action.resourceName);
      const fields = c.getFields();
      for (const field of fields) {
        fieldsObj[field.options.name] = field;
      }
      let appendSet = /* @__PURE__ */ new Set();
      if (params.updateAssociationValues) {
        appendSet = new Set(params.updateAssociationValues);
      }
      for (const key of appendSet) {
        if (!fieldsObj[key]) {
          continue;
        }
        const type = fieldsObj[key].options.type;
        if (type === "virtual") {
          appendSet.delete(key);
          continue;
        }
      }
      let dataBefore = (await repo.findOne({
        filter: {
          id: params.filterByTk
        },
        appends: [...appendSet]
      })).toJSON();
      const lostKeys = getLostKey(dataBefore, params.values);
      for (const lostKey of lostKeys) {
        if (lostKey.includes(".") || fieldsObj[lostKey] !== void 0 && ["belongsTo", "belongsToMany", "hasOne", "hasMany"].includes(fieldsObj[lostKey].options.type)) {
          appendSet.add(lostKey);
        }
      }
      dataBefore = (await repo.findOne({
        filter: {
          id: params.filterByTk
        },
        appends: [...appendSet]
      })).toJSON();
      const changed = getDiffKeyExceptAfter(dataBefore, params.values);
      return {
        error: null,
        data: dataBefore,
        changed
      };
    } catch (err) {
      ctx.log.error(err);
      return {
        error: err.stack
      };
    }
  };
}
class WebhookController {
  async getLink(ctx) {
    const {
      params: { name }
    } = ctx.action;
    const where = {};
    if (name) {
      where["filter"] = {
        name,
        type: "code",
        enabled: true
      };
    }
    if (!name) {
      throw new Error("not support");
    }
    const { currentUser, currentRole } = ctx.state;
    const { model: UserModel } = ctx.db.getCollection("users");
    const userInfo = {
      user: UserModel.build(currentUser).desensitize(),
      roleName: currentRole
    };
    const pluginWorkflow = ctx.app.getPlugin(import__.PluginWorkflow);
    const repo = ctx.db.getRepository("webhooks");
    const webhook = await repo.findOne(where);
    const webhookCtx = {
      request: ctx.request,
      action: ctx.action,
      body: ""
    };
    run(webhook.code, {
      ctx: webhookCtx,
      lib: {
        JSON,
        Math,
        dayjs: import_utils.dayjs
      }
    });
    if (webhook == null ? void 0 : webhook.workflowKey) {
      const wfRepo = ctx.db.getRepository("workflows");
      const wf = await wfRepo.findOne({ filter: { key: webhook.workflowKey, enabled: true } });
      const processor = await pluginWorkflow.trigger(wf, { data: webhookCtx.body, ...userInfo }, { httpContext: ctx });
      if (!processor) {
        return ctx.throw("Workflow should be sync.", 500);
      }
      const { lastSavedJob } = processor;
      if (typeof ctx.body === "undefined") {
        ctx.withoutDataWrapping = true;
        ctx.body = lastSavedJob.result;
      }
      return;
    }
    if (webhookCtx.body) {
      ctx.withoutDataWrapping = true;
      ctx.body = webhookCtx.body;
      return;
    }
  }
  async test(ctx) {
    const { name, params, body } = ctx.action.params.values;
    ctx.request.query = params;
    ctx.action.params = params || {};
    ctx.action.params.name = name;
    ctx.action.params.values = body;
    await new WebhookController().getLink(ctx);
  }
  async action(ctx, action) {
    const webhookCtx = {
      request: ctx.request,
      action: ctx.action,
      body: "",
      getChanged: getChanged(ctx)
    };
    try {
      await evalSimulate(action.code, {
        ctx: webhookCtx,
        lib: {
          JSON,
          Math,
          dayjs: import_utils.dayjs
        }
      });
      return webhookCtx.body;
    } catch (err) {
      ctx.app.log.error(err);
      return null;
    }
  }
  async triggerWorkflow(ctx, action, body) {
    const { currentUser, currentRole } = ctx.state;
    const { model: UserModel } = ctx.db.getCollection("users");
    if (!action.workflowKey) {
      return;
    }
    const userInfo = {
      user: UserModel.build(currentUser).desensitize(),
      roleName: currentRole
    };
    const pluginWorkflow = ctx.app.getPlugin(import__.PluginWorkflow);
    const wfRepo = ctx.db.getRepository("workflows");
    const wf = await wfRepo.findOne({ filter: { key: action.workflowKey, enabled: true } });
    await pluginWorkflow.trigger(wf, { data: body, ...userInfo }, { httpContext: ctx });
  }
}
function run(jsCode, { ctx, lib }) {
  try {
    return new Function("$root", `with($root) { ${jsCode}; }`)({ ctx, lib });
  } catch (err) {
    console.log("err", err);
  }
}
async function evalSimulate(jsCode, { ctx, lib }) {
  const AsyncFunction = async function() {
  }.constructor;
  return await new AsyncFunction("$root", `with($root) { ${jsCode}; }`)({
    ctx,
    // 允许用户覆盖，这个时候可以使用 _ctx
    __ctx: ctx,
    lib
  });
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  WebhookController
});
